package inria.meije.rc.sugarcubes;

public class Control extends UnaryInstruction
{
    protected String eventName;

    public Control(String s,Instruction inst){ eventName = s; body = inst; }

    public String toString(){ return "control "+body+" by "+eventName; }
    protected Instruction rest(){ 
        return new Control(eventName,body.residual()); 
    }
    protected byte activation(Context context){ 
        if (((Domain)context).isGenerated(eventName))
            return body.activ(context);
        else
            if(context.isEndOfInstant())
                return STOP;
            else
                return SUSP;
    }
}
